Triggers = {}
CollectionsUsed = {8, 12}
moving_ephemera = {}
BRUTAL_MARATHON_OWNER = "BRUTAL MARATHON"
MAX_RENDERED_COUNT = 1400

BulletDecals = {}
BulletDecals["pistol bullet"] = true
BulletDecals["rifle bullet"] = true
BulletDecals["shotgun bullet"] = true
BulletDecals["trooper bullet"] = true
BulletDecals["smg bullet"] = true

ExplosionDecals = {}
ExplosionDecals["grenade"] = true
ExplosionDecals["staff bolt"] = true
ExplosionDecals["compiler bolt minor"] = true
ExplosionDecals["compiler bolt major"] = true
ExplosionDecals["alien weapon"] = true
ExplosionDecals["fusion bolt minor"] = true
ExplosionDecals["fusion bolt major"] = true
ExplosionDecals["hunter"] = true
ExplosionDecals["juggernaut rocket"] = true
ExplosionDecals["trooper grenade"] = true
ExplosionDecals["minor defender"] = true
ExplosionDecals["major defender"] = true
ExplosionDecals["juggernaut missile"] = true
ExplosionDecals["minor hummer"] = true
ExplosionDecals["major hummer"] = true
ExplosionDecals["durandal hummer"] = true
ExplosionDecals["minor cyborg ball"] = true
ExplosionDecals["major cyborg ball"] = true
ExplosionDecals["minor fusion dispersal"] = true
ExplosionDecals["major fusion dispersal"] = true
ExplosionDecals["lava yeti"] = true

BigExplosionDecals = {}
BigExplosionDecals["missile"] = true

function Triggers.init()
    enabled = Game.version > "20200904"
    ephemera_count = 0
    max_ephemera = math.ceil(#Ephemera / 2) -- Leave room for other types of ephemera
    deaths = 0
end

function Triggers.idle()
    if enabled then
        for i = #moving_ephemera, 1, -1 do
            local e = update_ephemera(moving_ephemera[i])
            if not e then
                table.remove(moving_ephemera, i)
            end
        end

        -- Casualties sound
        if deaths > 6 then
            for p in Players() do
                p:play_sound(139)
            end
            deaths = 0
        end

        -- Try to keep frame rate high
        if Game.ticks % 30 == 0 then
            cleanup_ephemera_in_view()

            -- Keep track of recent deaths for casualties sound
            if Game.ticks % 60 == 0 then
                if deaths > 0 then
                    deaths = deaths - 1
                end
            end
        end
    end
end

function Triggers.monster_killed(monster, aggressor_player, projectile)
    if enabled then
        if projectile then
            local explode = 0
            if
                projectile.type == "grenade" or projectile.type == "compiler bolt minor" or
                    projectile.type == "compiler bolt major" or
                    projectile.type == "fusion bolt major" or
                    projectile.type == "juggernaut rocket" or
                    projectile.type == "trooper grenade" or
                    projectile.type == "juggernaut missile" or
                    projectile.type == "overloaded fusion disperal"
             then
                explode = 1
            end
            if monster.type.class == "cyborg" or monster.type == "mother of all hunters" then
                explode = 1
            elseif monster.type.class == "hunter" and projectile.type == "fusion bolt minor" then
                explode = 1
            end
            if projectile.type == "missile" then
                explode = 2
            end
            if projectile.type == "flamethrower burst" or projectile.type == "alien weapon" then
                local c = monster.type.class
                if
                    c == "player" or c == "bob" or c == "fighter" or c == "trooper" or c == "enforcer" or
                        c == "explodabob"
                 then
                    explode = 3
                end
            end
            local direction = angle_between_points(projectile, monster)
            explode_monster(monster, explode, direction)
        else
            explode = 1
            explode_monster(monster, explode)
        end
    end
end

function Triggers.player_killed(player, aggressor_player, action, projectile)
    if enabled then
        if projectile then
            local explode = 0
            if
                projectile.type == "grenade" or projectile.type == "compiler bolt minor" or
                    projectile.type == "compiler bolt major" or
                    projectile.type == "fusion bolt major" or
                    projectile.type == "juggernaut rocket" or
                    projectile.type == "trooper grenade" or
                    projectile.type == "juggernaut missile" or
                    projectile.type == "overloaded fusion disperal"
             then
                explode = 1
            end
            if projectile.type == "missile" then
                explode = 2
            end
            if projectile.type == "flamethrower burst" or projectile.type == "alien weapon" then
                explode = 3
            end
            local direction = angle_between_points(projectile, player)
            explode_monster(player.monster, explode, direction)
        else
            explode = 1
            explode_monster(player.monster, explode)
        end
    end
end

function Triggers.player_damaged(victim, aggressor_player, aggressor_monster, damage_type, damage_amount, projectile)
    spill_blood(victim.monster, projectile)
end

function Triggers.monster_damaged(monster, aggressor_monster, damage_type, damage_amount, projectile)
    spill_blood(monster, projectile)
end

function spill_blood(monster, projectile)
    local m = monster
    local col, seq, ct = get_ephemera_by_blood(m.type)


    if not col or (not m.player and m.life < 0) then
        return
    end

    local num = 1
    if Ephemera.quality == "ultra" then
        num = 3
    elseif Ephemera.quality == "high" then
        num = 2
    end

    if
        projectile and
            (projectile.type == "missile" or projectile.type == "grenade" or projectile.type == "compiler bolt major" or
                projectile.type == "fusion bolt major" or
                projectile.type == "juggernaut rocket" or
                projectile.type == "trooper grenade" or
                projectile.type == "juggernaut missile" or
                projectile.type == "minor cyborg ball" or
                projectile.type == "major cyborg ball")
     then
        num = num * 3
    end

    for i = 1, num do
        local facing = Game.random_local(360)
        local e = create_ephemera(m.x, m.y, m.z + .4 + Game.random_local(3) / 10.0, m.polygon, col, seq, facing)

        if e then
            table.insert(moving_ephemera, e)

            e._horizontal_dist = Game.random_local(30) / 750.0
            e._vertical_velocity = .02
            e._vertical_velocity_step = -.002
            e._terminal_velocity = -.09
            e._max_bounces = 0
            e._bounces = 0
            e._moving_horizontally = true
            e._active = true
            e.clut_index = ct
        end
    end
end

function explode_monster(m, explode, proj_facing)
    deaths = deaths + 1

    if Ephemera.quality == "off" then
        return
    end

    local col, seq, ct, num = get_ephemera_by_monster(m)

    if Ephemera.quality == "ultra" then
        num = num * 4
    elseif Ephemera.quality == "high" then
        num = num * 2
    elseif Ephemera.quality == "low" then
        num = math.ceil(num * .5)
    end

    if col and seq and ct then
        for i = 1, num do
            if explode == 3 then
                col, seq, ct = get_ephemera_by_flaming_death(m)
            else
                col, seq, ct, num = get_ephemera_by_monster(m)
            end
            local facing = nil
            if proj_facing and m.type.class ~= "compiler" then
                local rand = -45 + Game.random_local(90)
                facing = proj_facing + rand
            else
                facing = Game.random_local(360)
            end
            local e = create_ephemera(m.x, m.y, m.z + .2 + Game.random_local(5) / 10.0, m.polygon, col, seq, facing)

            if e then
                table.insert(moving_ephemera, e)

                if m.type == "mother of all cyborgs" or m.type == "mother of all hunters" then
                    e.enlarged = true
                end

                e._horizontal_dist = Game.random_local(100) / 750.0
                if explode == 1 then
                    e._vertical_velocity = .05 + (Game.random_local(5) / 100.0)
                elseif explode == 2 then
                    e._vertical_velocity = .08 + (Game.random_local(5) / 100.0)
                    e._horizontal_dist = (50 + Game.random_local(50)) / 300.0
                elseif explode == 3 then
                    e._vertical_velocity = .02
                else
                    e._vertical_velocity = .01
                end
                e._vertical_velocity_step = -.002
                e._terminal_velocity = -.09
                e._max_bounces = 2
                e._bounces = 0
                e._moving_horizontally = true
                e._active = true
                e.clut_index = ct

                if m.type.class == "compiler" then
                    local z = m.z + (Game.random_local(85) / 100)
                    e:position(e.x, e.y, z, e.polygon)
                    e._vertical_velocity = Game.random_local(15) / 1000
                    if Game.random_local(2) == 0 then
                        e._vertical_velocity = e._vertical_velocity * -1
                    end
                    e._vertical_velocity_step = 0
                    e._terminal_velocity = 0
                    e._horizontal_dist = .005 + (Game.random_local(10) / 1000)
                end

                if m.type.class == "defender" then
                    e._delete_tick = Game.ticks + 35
                elseif m.type.class == "compiler" then
                    e._delete_tick = Game.ticks + 5 + Game.random_local(40)
                end
            end
        end
    end
end

function update_ephemera(e)
    if not e._active then
        return nil
    end

    if e._delete_tick and e._delete_tick == Game.ticks then
        e:delete()
        return nil
    end

    if e.z > e.polygon.floor.z or e._vertical_velocity > 0 then
        local vv = e._vertical_velocity + e._vertical_velocity_step
        if vv < e._terminal_velocity then
            vv = e._terminal_velocity
        end
        e._vertical_velocity = vv
        local z = e.z + e._vertical_velocity

        if z > e.polygon.ceiling.z then
            z = e.polygon.ceiling.z
        elseif z < e.polygon.floor.z then
            z = e.polygon.floor.z
        end

        local x = e.x
        local y = e.y
        local poly = e.polygon
        x, y, poly = get_offset_location(e.x, e.y, e.z, e.polygon, e.facing, e._horizontal_dist)

        -- If hit a wall, try picking a new random direction to move in
        if not poly then
            local chdir = 90 + Game.random_local(45)
            if Game.random_local(2) == 0 then
                chdir = chdir * -1
            end
            e.facing = e.facing + chdir

            x, y, poly = get_offset_location(e.x, e.y, e.z, e.polygon, e.facing, e._horizontal_dist)

            if poly then
                e._horizontal_dist = e._horizontal_dist / 6
                if e._vertical_velocity > 0 then
                    e._vertical_velocity = e._vertical_velocity / 2
                end
            end
        end

        if not poly then
            x, y, poly = e.x, e.y, e.polygon
        end

        if poly then
            e:position(x, y, z, poly)
        end

        return e
    elseif e._delete_tick then
        return e
    elseif e._vertical_velocity <= -.09 then
        e._vertical_velocity = .03
        return e
    else
        e._active = false
        return nil
    end
end

-- Bullet decals
function Triggers.projectile_detonated(type, owner, polygon, x, y, z, t)
    if t then
        local decal_col = 4
        decal_seq = nil

        if BulletDecals[type.mnemonic] then
            decal_seq = 34
        elseif ExplosionDecals[type.mnemonic] then
            decal_seq = 35
        elseif BigExplosionDecals[type.mnemonic] then
            decal_seq = 36
        end

        if decal_seq then
            local create = false
            if is_side(t) then
                if (t.type == "full" or t.type == "high" or t.type == "low") and t.primary.transfer_mode ~= "landscape" then
                    create = true
                else -- split
                    if z < t.line.highest_adjacent_floor and t.secondary.transfer_mode ~= "landscape" then
                        create = true
                    elseif z > t.line.lowest_adjacent_ceiling and t.primary.transfer_mode ~= "landscape" then
                        create = true
                    end
                end

                if
                    (t.line.cw_polygon and t.line.cw_polygon.type == "platform") or
                        (t.line.ccw_polygon and t.line.ccw_polygon.type == "platform")
                 then
                    create = false
                end
            elseif (is_polygon_floor(t) or is_polygon_ceiling(t)) and t.transfer_mode ~= "landscape" then
                create = true
            end

            if create then
                -- Additional ephemera to cover a larger area
                if decal_seq == 35 or decal_seq == 36 then
                    local spacing = .015
                    local bigspacing = false
                    if decal_seq == 36 then
                        spacing = .04
                        bigspacing = true
                    end
                    if is_side(t) then
                        local pt = {x = x, y = y}
                        local angle = angle_between_points(pt, t.line.endpoints[0])

                        for i = 0, 4 do
                            local nrow = i - 2
                            local num = 1
                            if i == 1 or i == 3 then
                                num = 2
                            elseif i == 2 then
                                num = 3
                            end
                            for k = 0, num - 1 do
                                local ncol = k - (num / 2)
                                local x2, y2, poly2 =
                                    get_offset_location(
                                    x,
                                    y,
                                    z,
                                    polygon,
                                    angle,
                                    (spacing * nrow) + random_spacing(bigspacing)
                                )
                                if poly2 then
                                    create_ephemera(
                                        x2,
                                        y2,
                                        z + (spacing * ncol) + random_spacing(bigspacing),
                                        poly2,
                                        decal_col,
                                        decal_seq,
                                        0
                                    )
                                end
                            end
                        end
                    else
                        for i = 0, 4 do
                            local nx = i - 2
                            local num = 1
                            if i == 1 or i == 3 then
                                num = 2
                            elseif i == 2 then
                                num = 3
                            end
                            for k = 0, num - 1 do
                                local ny = k - (num / 2)
                                local x2 = x + (nx * spacing) + random_spacing(bigspacing)
                                local y2 = y + (ny * spacing) + random_spacing(bigspacing)
                                local poly2 = polygon:find_polygon(x, y, x2, y2)
                                if poly2 then
                                    create_ephemera(x2, y2, z, poly2, decal_col, decal_seq, 0)
                                end
                            end
                        end
                    end
                else
                    create_ephemera(x, y, z, polygon, decal_col, decal_seq, 0)
                end
            end
        end
    end
end

function random_spacing(bigspacing)
    local rand = Game.random_local(10) / 1000
    if bigspacing then
        rand = Game.random_local(15) / 1000
    end
    if Game.random_local(2) == 0 then
        rand = rand * -1
    end
    return rand
end

function create_ephemera(x, y, z, polygon, col, seq, facing)
    if ephemera_count >= max_ephemera then
        cleanup()
    end

    local e = Ephemera.new(x, y, z, polygon, col, seq, facing)
    if not e then
        cleanup()
        e = Ephemera.new(x, y, z, polygon, col, seq, facing)
    end
    if e then
        ephemera_count = ephemera_count + 1
        e._owner = BRUTAL_MARATHON_OWNER
    end
    return e
end

function cleanup_ephemera_in_view()
    local rendered_ephemera = {}
    for e in Ephemera() do
        if e._owner == BRUTAL_MARATHON_OWNER and e.rendered and not e._active then
            table.insert(rendered_ephemera, e)
        end
    end

    -- Players.print("Rendered: " .. #rendered_ephemera .. ", total: " .. ephemera_count)
    if #rendered_ephemera > MAX_RENDERED_COUNT then
        cleanup(rendered_ephemera)
    end
end

function cleanup(ephemera)
    local count = 0

    if ephemera then
        for i = #ephemera, 1, -1 do
            local e = ephemera[i]
            if count % 3 == 0 and e and e._owner == BRUTAL_MARATHON_OWNER and not e._active then
                e:delete()
                ephemera_count = ephemera_count - 1
            end
            count = count + 1
        end
    else
        for e in Ephemera() do
            if count % 3 == 0 and e and e._owner == BRUTAL_MARATHON_OWNER and not e._active then
                e:delete()
                ephemera_count = ephemera_count - 1
            end
            count = count + 1
        end
    end
end

function get_offset_location(x, y, z, polygon, angle, dist)
    local nx, ny = calc_offset_location(x, y, angle, dist)
    local poly = polygon:find_polygon(x, y, nx, ny)

    -- Don't move into polygons if the floor or ceiling block the movement
    if poly and (z <= poly.floor.height or z >= poly.ceiling.height) then
        poly = nil
    end

    return nx, ny, poly
end

function calc_offset_location(x, y, angle, dist)
    angle = angle * math.pi / 180
    return x + math.cos(angle) * dist, y + math.sin(angle) * dist
end

function get_ephemera_by_monster(m)
    local num = 8
    local col = m.type.collection

    local seq = get_gore_sequence(col)
    local ct = m.type.clut_index

    if m.player then
        ct = m.player.color.index
    end

    if m.type.class == "juggernaut" then
        num = 30
    elseif m.type.class == "tick" then
        num = 5
    elseif m.type.class == "defender" then
        num = 30
    elseif m.type.class == "drone" or m.type.class == "possessed drone" then
        num = 6
    elseif m.type.class == "compiler" then
        num = 50
    elseif m.type == "mother of all cyborgs" or m.type == "mother of all hunters" then
        num = 20
    end

    if col == 7 then -- Items (potato anus, etc)
        num = 0
        seq = nil
    end

    return col, seq, ct, num
end

function get_ephemera_by_flaming_death()
    local col = 4
    local seq = 30 + Game.random_local(4)
    local ct = 0

    return col, seq, ct
end

function has_blood(type)
    col = get_ephemera_by_blood(type)
    return col ~= nil
end

function get_ephemera_by_blood(type)
    if type == "player" or type.class == "bob" or type == "lava yeti" then
        return get_red_blood_ephemera()
    elseif
        type.class == "tick" or type.class == "fighter" or type.class == "trooper" or type.class == "enforcer" or
            type.class == "explodabob" or
            type == "sewage yeti" or
            type == "water yeti"
     then
        return get_yellow_blood_ephemera()
    elseif type.class == "cyborg" then
        return get_purple_blood_ephemera()
    end

    return nil
end

function get_yellow_blood_ephemera()
    local col = 8
    local seq = 11
    local ct = 0
    return col, seq, ct
end

function get_red_blood_ephemera()
    local col = 12
    local seq = 14
    local ct = 0
    return col, seq, ct
end

function get_purple_blood_ephemera()
    local col = 31
    local seq = 10
    local ct = 0
    return col, seq, ct
end

function get_gore_sequence(col)
    if col == 9 then
        return 13
    elseif col == 2 then
        return 9 + Game.random_local(2)
    elseif col == 3 then
        return 7 + Game.random_local(2)
    elseif col == 5 then
        return 11 + Game.random_local(2)
    elseif col == 8 then
        if Game.random_local(2) == 0 then
            return 10
        end
        return 12
    elseif col == 10 then
        return 9
    elseif col == 11 then
        return 14 + Game.random_local(2)
    elseif col == 12 then
        local rand = Game.random_local(3)
        if rand == 0 then
            return 13
        elseif rand == 1 then
            return 15
        end
        return 16
    elseif col == 14 then
        return 8 + Game.random_local(2)
    elseif col == 15 then
        return 8 + Game.random_local(2)
    elseif col == 16 then
        return 8
    elseif col == 6 then
        return 35 + Game.random_local(3)
    elseif col == 13 then
        return 14 + Game.random_local(3)
    elseif col == 31 then
        if Game.random_local(2) == 0 then
            return 9
        end
        return 11
    else
        return 9
    end
end

function cheat()
    Players.print("Nobody likes a cheater :C")
    for p in Players() do
        p.items["pistol"] = 2
        p.items["assault rifle"] = 1
        p.items["fusion pistol"] = 1
        p.items["missile launcher"] = 1
        p.items["alien weapon"] = 1
        p.items["flamethrower"] = 1
        p.items["shotgun"] = 2
        p.items["smg"] = 1

        p.items["pistol ammo"] = 50
        p.items["assault rifle ammo"] = 15
        p.items["assault rifle grenades"] = 8
        p.items["fusion pistol ammo"] = 25
        p.items["missile launcher ammo"] = 4
        p.items["flamethrower ammo"] = 3
        p.items["shotgun ammo"] = 80
        p.items["smg ammo"] = 20
    end
end

---- The following functions taken from
---- https://gist.github.com/kirubz/fa84375008d376a2d695618e0ae3aed8/9812f1407136ca1ef795d484162d05ad2c7eb2b8
function angleOfPoint(pt)
    local x, y = pt.x, pt.y
    local radian = math.atan2(y, x)
    local angle = radian * 180 / math.pi
    if angle < 0 then
        angle = 360 + angle
    end
    return angle
end

-- returns the degrees between two points (note: 0 degrees is 'east')
function angle_between_points(a, b)
    local x, y = b.x - a.x, b.y - a.y
    return angleOfPoint({x = x, y = y})
end
----
